/*
 * name DataRepTest.pde
 * date Thu Feb 07 13:49:29 JST 2013
 * 
 * Released under the 'Buy Me a Beer' license
 * (If we ever meet, you buy me a beer)
 */

import net.triring.emuduino.*;
import ddf.minim.AudioOutput;
// Pin割り当て
// constants won't change. They're used here to 
// set pin numbers:
int         A0 =   0;  // Slider:OUTPUT
int         A1 =   1;  // Slider:OUTPUT
int         A2 =   2;  // Slider:OUTPUT
int         A3 =   3;  // Slider:OUTPUT
int        A10 =  10;  // DataReproducer
int        A11 =  11;  // DataReproducer
int        A12 =  12;  // DataReproducer
int        A13 =  13;  // DataReproducer

void setup() {
   // データ再生テスト 
   // data_reproducerから，sin波，cos波にデータを読み込み，Slider0-3に出力します。
   // データは，data/sin_cos.csvを読み込んで，Playボタンをクリックしてください。
   
  initComponents();
//data_reproducer.load_Data("data/sin_cos.csv");
//data_reproducer.load_Data("D:\\nbdir\\EmuduinoDesigner\\data\\sin_cos.csv");
  data_reproducer.load_Data("data\\sin_cos.csv");
}

void loop() {
  analogWrite(A0, analogRead(A10));
  analogWrite(A1, analogRead(A11));
  analogWrite(A2, analogRead(A12));
  analogWrite(A3, analogRead(A13));
  delay(100);
}

void draw() {
  loop();
}

// システムの機能を完全に停止させる禁断のメソッド
// 決して、使ってはならない。
void balse() {
  System.exit(0);
}                                            

// analog OUTPUT
void analogWrite(int inPin, int value) {
    switch (inPin) {
        case 0 : slider0.setValue(value);
                  break;
        case 1 : slider1.setValue(value);
                  break;
        case 2 : slider2.setValue(value);
                  break;
        case 3 : slider3.setValue(value);
                  break;
    }
}
// analog INPUT
int analogRead(int inPin) {
    int value = 0;
    switch (inPin) {
        case  10 : value = data_reproducer.getValue( 0); break;
        case  11 : value = data_reproducer.getValue( 1); break;
        case  12 : value = data_reproducer.getValue( 2); break;
        case  13 : value = data_reproducer.getValue( 3); break;
    }
    return value;
}
java.awt.Image readImage(String imgfile) {
  PImage pImage = loadImage(imgfile);
  return pImage.getImage();
}

//TimerTask内部クラス
class TimerTaskAudioStop extends java.util.TimerTask {
  public void run() {
    ToneFlag = 0;
    auOut.noSound();
    auOut.mute();
  }
}

// 指定された時間だけ停止する。単位はus
void delayMicroseconds(int t_us) {
  try {
    Thread.sleep(0, t_us * 1000);  // マイクロ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// 指定された時間だけ停止する。単位はms
void delay(long t_ms) {
  try {
    Thread.sleep(t_ms);  // ミリ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// arduino起動後の時間をus単位で返す。
long micros() {
  return (SystemStartTimeNS - System.nanoTime()) * 1000;
}

// 以下は、互換性のためだけに用意したダミー関数である。
void pinMode(int pin, int mode) {
   print("pin = " + pin + ", mode = " + mode);
}

/**
 * This method is called from within the constructor to initialize the form.
 * WARNING: Do NOT modify this code. The content of this method is always
 * regenerated by the Form Editor.
 */
// @SuppressWarnings("unchecked")
// <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
private void initComponents() {
  ToneFlag = 0;

  // digital
                   slider0 = new Slider(0 , "OUTPUT0",    0,  240, javax.swing.JSlider.VERTICAL  );
                   slider1 = new Slider(1 , "OUTPUT1",  120,  240, javax.swing.JSlider.VERTICAL  );
                   slider2 = new Slider(2 , "OUTPUT2",  240,  240, javax.swing.JSlider.VERTICAL  );
                   slider3 = new Slider(3 , "OUTPUT3",  360,  240, javax.swing.JSlider.VERTICAL  );
           data_reproducer = new DataReproducer("DataReproducer",  480,  240);
  

  minim = new ddf.minim.Minim(this);
  // get a line out from Minim, default bufferSize is 1024, default sample rate is 44100, bit depth is 16
  auOut = minim.getLineOut(ddf.minim.Minim.STEREO);
  // create a sine wave Oscillator, set to 440 Hz, at 0.5 amplitude, sample rate from line out
  sine = new ddf.minim.signals.SineWave(440, 0.5, auOut.sampleRate());
  // set the portamento speed on the oscillator to 200 milliseconds
  sine.portamento(200);

  DelayTimer = new java.util.Timer(); //タイマーインスタンス作成

  // add the oscillator to the line out
  auOut.addSignal(sine);
  auOut.noSound();  // Disables all signals currently attached to this.
  auOut.mute();
  ToneFlag = 0;

  SystemStartTimeMS = System.currentTimeMillis();  //ミリ秒で表される現在の時間を返します。
  SystemStartTimeNS = System.nanoTime(); // 利用可能でもっとも正確なシステムタイマーの現在の値をナノ秒単位で返します。
  size(320, 128);
  setLocation(0, 600);
  background(15, 115, 145);
  fill( 15, 115, 145);  rect(0, 0, 320, 128);
  fill( 30, 160, 145);  textSize(60); text(TITLE , 24, 68);
  fill( 45, 192, 145);  textSize(60); text(TITLE , 22, 66);
  fill(255, 255, 255);  textSize(60); text(TITLE , 20, 64);
  fill(255, 255, 255);  textSize(18); text("Ver. " + Arduino.getVersion(), 120, 108);
  setLocation(0, 600);
}// </editor-fold>//GEN-END:initComponents

// 変数の宣言部
// Variables declaration - do not modify//GEN-BEGIN:variables

private String TITLE   = "Emuduino";
private String VERSION = "0.49"; // Arduino.javaで使用するプロパティファイル中のバージョンを参照する。

private long SystemStartTimeMS;
private long SystemStartTimeNS;

private static final int HIGH   = 0x1;
private static final int LOW    = 0x0;
private static final int INPUT  = 0x0;
private static final int OUTPUT = 0x1;

// private static final int A0     = 0x0;
// private static final int A1     = 0x1;
// private static final int A2     = 0x2;
// private static final int A3     = 0x3;
// private static final int A4     = 0x4;
// private static final int A5     = 0x5;
// private static final int A6     = 0x6;
// private static final int A7     = 0x7;
// private static final int A8     = 0x8;
// private static final int A9     = 0x9;

private int ToneFlag = 0;  // 0の場合は停止状態。再生中は，その周波数を保持

private java.util.Timer            DelayTimer;
private java.util.TimerTask        TimerTaskAudioStop;
private ddf.minim.Minim            minim; // http://code.compartmental.net/minim/javadoc/
private ddf.minim.AudioOutput      auOut;
private ddf.minim.signals.SineWave sine;

private Slider slider0;
private Slider slider1;
private Slider slider2;
private Slider slider3;
private DataReproducer data_reproducer;


// End of variables declaration//GEN-END:variables


