/*
 * name ActivityLimitation.pde
 * date Sun Feb 10 11:00:09 JST 2013
 * 
 * Released under the 'Buy Me a Beer' license
 * (If we ever meet, you buy me a beer)
 */

import net.triring.emuduino.*;
import ddf.minim.AudioOutput;
// Pin割り当て
// constants won't change. They're used here to 
// set pin numbers:
int         sw =   2;  // Switch:Push
int     ledRed =   3;  // Led:Red
int    speaker =  10;  // Speaker:
int  S19 =  19;  // SevenSegmentDisplay
int  S18 =  18;  // SevenSegmentDisplay

int count = 0;
int RemainingTime = 3000;

void setup() {
  // カウントダウンタイマー(5分)です。
  // 某アニメの活動限界を示すパネルをイメージして作ってみました。
  // ランダムに点滅する赤色LEDで緊迫感を演出しています。  
  initComponents();

  // initialize

     pinMode(sw,  INPUT);  // Switch:Push
     pinMode(ledRed, OUTPUT);  // Led:Red
     pinMode(speaker, OUTPUT);  // Speaker:

  // RemainingTime = 3000;  // 5min
     RemainingTime =    0;
}

void loop() {
  int m01   = 0;
  int s10   = 0;
  int s01   = 0;
  int ms100 = 0;
  int tmp = 0;
  
  tmp   = RemainingTime / 600;
  m01   = tmp % 10; 
  tmp   = RemainingTime % 600;
  s10   = tmp / 100; 
  s01   = (tmp % 100) / 10; 
  ms100 = (tmp % 100) % 10; 
  
  disp7SEG1(0 , m01  );
  disp7SEG1(1 , s10  );
  disp7SEG1(2 , s01  );
  disp7SEG1(3 , ms100);
  RemainingTime--;
  if (RemainingTime > 0) {
    if (0 == ms100) {
      tone(9, 2252);   delay(25);
      noTone(speaker); delay(75);
      int r = (int)random(0, 50);
      if (0 == (r % 2)) {
        digitalWrite(ledRed, HIGH);
      } else {
        digitalWrite(ledRed, LOW );
      }
    }
  } else {
     delay(100);   
     RemainingTime = 0;
  }
  if (HIGH == digitalRead(sw)) {
     RemainingTime = 3000;   // start
  }

}

void draw() {

  loop();
}

// システムの機能を完全に停止させる禁断のメソッド
// 決して、使ってはならない。
void balse() {
  System.exit(0);
}                                            

// digital INPUT
int digitalRead(int inPin) {
    int value = 0;
    switch (inPin) {
        case 2 : value = switch2.isState(); break;
    }
    return value;
}
// digital OUTPUT
void digitalWrite(int outPin, int value) {
    switch (outPin) {
        case 3 : led3.setState(value); break;
    }
}
// Speakerで使用する関数群

void tone(int pin, int frequency) {
  if (ToneFlag == frequency) return;
  ToneFlag = frequency;
  speaker10.setFrequency(frequency);
  sine.setFreq((float)frequency);
  auOut.unmute();
  auOut.sound();
}

void tone(int pin, int frequency, long duration) {
  if (ToneFlag == frequency) return;
  ToneFlag = frequency;
  sine.setFreq((float)frequency);
  auOut.unmute();
  auOut.sound();
  TimerTaskAudioStop timerTask = new TimerTaskAudioStop(); //タイマータスクインスタンス作成
  //タイマー開始
  DelayTimer.schedule(timerTask, duration);
}

void noTone(int pin) {
  ToneFlag = 0;
  speaker10.setFrequency(0);
  auOut.mute();
  auOut.noSound();
}
// Seven Segment Display
void disp7SEG1(int n, int value) {
  // n     : 7seg number  0 - 4
  // value : 0 - 15
  switch (n) {
    case  0 : ssd1[0].setValue(value); break;
    case  1 : ssd1[1].setValue(value); break;
    case  2 : ssd1[2].setValue(value); break;
    case  3 : ssd1[3].setValue(value); break;

  }
}
java.awt.Image readImage(String imgfile) {
  PImage pImage = loadImage(imgfile);
  return pImage.getImage();
}

//TimerTask内部クラス
class TimerTaskAudioStop extends java.util.TimerTask {
  public void run() {
    ToneFlag = 0;
    auOut.noSound();
    auOut.mute();
  }
}

// 指定された時間だけ停止する。単位はus
void delayMicroseconds(int t_us) {
  try {
    Thread.sleep(0, t_us * 1000);  // マイクロ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// 指定された時間だけ停止する。単位はms
void delay(long t_ms) {
  try {
    Thread.sleep(t_ms);  // ミリ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// arduino起動後の時間をus単位で返す。
long micros() {
  return (SystemStartTimeNS - System.nanoTime()) * 1000;
}

// 以下は、互換性のためだけに用意したダミー関数である。
void pinMode(int pin, int mode) {
   print("pin = " + pin + ", mode = " + mode);
}

/**
 * This method is called from within the constructor to initialize the form.
 * WARNING: Do NOT modify this code. The content of this method is always
 * regenerated by the Form Editor.
 */
// @SuppressWarnings("unchecked")
// <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
private void initComponents() {
  ToneFlag = 0;

  // digital
                   switch2 = new Switch(2 , "Push2",    0,  300);
                      led3 = new Led(3 , "red",    0,    0);
                 speaker10 = new Speaker(10 , "speaker10",  120,  300);
  ssd1 = new SevenSegmentDisplay[4]; for (int i = 0; i < 4; i++) { ssd1[i] = new SevenSegmentDisplay(1 , "SSD 1", 120 + 144 * i, 0); }
  

  minim = new ddf.minim.Minim(this);
  // get a line out from Minim, default bufferSize is 1024, default sample rate is 44100, bit depth is 16
  auOut = minim.getLineOut(ddf.minim.Minim.STEREO);
  // create a sine wave Oscillator, set to 440 Hz, at 0.5 amplitude, sample rate from line out
  sine = new ddf.minim.signals.SineWave(440, 0.5, auOut.sampleRate());
  // set the portamento speed on the oscillator to 200 milliseconds
  sine.portamento(200);

  DelayTimer = new java.util.Timer(); //タイマーインスタンス作成

  // add the oscillator to the line out
  auOut.addSignal(sine);
  auOut.noSound();  // Disables all signals currently attached to this.
  auOut.mute();
  ToneFlag = 0;

  SystemStartTimeMS = System.currentTimeMillis();  //ミリ秒で表される現在の時間を返します。
  SystemStartTimeNS = System.nanoTime(); // 利用可能でもっとも正確なシステムタイマーの現在の値をナノ秒単位で返します。
  size(320, 128);
  setLocation(0, 600);
  background(15, 115, 145);
  fill( 15, 115, 145);  rect(0, 0, 320, 128);
  fill( 30, 160, 145);  textSize(60); text(TITLE , 24, 68);
  fill( 45, 192, 145);  textSize(60); text(TITLE , 22, 66);
  fill(255, 255, 255);  textSize(60); text(TITLE , 20, 64);
  fill(255, 255, 255);  textSize(18); text("Ver. " + Arduino.getVersion(), 120, 108);
  setLocation(0, 600);
}// </editor-fold>//GEN-END:initComponents

// 変数の宣言部
// Variables declaration - do not modify//GEN-BEGIN:variables

private String TITLE   = "Emuduino";
private String VERSION = "0.49"; // Arduino.javaで使用するプロパティファイル中のバージョンを参照する。

private long SystemStartTimeMS;
private long SystemStartTimeNS;

private static final int HIGH   = 0x1;
private static final int LOW    = 0x0;
private static final int INPUT  = 0x0;
private static final int OUTPUT = 0x1;

// private static final int A0     = 0x0;
// private static final int A1     = 0x1;
// private static final int A2     = 0x2;
// private static final int A3     = 0x3;
// private static final int A4     = 0x4;
// private static final int A5     = 0x5;
// private static final int A6     = 0x6;
// private static final int A7     = 0x7;
// private static final int A8     = 0x8;
// private static final int A9     = 0x9;

private int ToneFlag = 0;  // 0の場合は停止状態。再生中は，その周波数を保持

private java.util.Timer            DelayTimer;
private java.util.TimerTask        TimerTaskAudioStop;
private ddf.minim.Minim            minim; // http://code.compartmental.net/minim/javadoc/
private ddf.minim.AudioOutput      auOut;
private ddf.minim.signals.SineWave sine;

private Switch switch2;
private Led led3;
private Speaker speaker10;
private SevenSegmentDisplay[] ssd1;


// End of variables declaration//GEN-END:variables

