/*
 * name LedCubePanel.pde
 * date Tue Feb 05 16:48:00 JST 2013
 * 
 * Released under the 'Buy Me a Beer' license
 * (If we ever meet, you buy me a beer)
 */

import net.triring.emuduino.*;
import ddf.minim.AudioOutput;

// Pin割り当て
// constants won't change. They're used here to 
// set pin numbers:

int Count = 0;
int Color = 0;
int Index = 0;

final static int  HEIGHT = 11; //高さ(z軸)
final static int  DEPTH  =  3; //奥行(y軸)
final static int  WIDTH  =  3; //幅(x軸)

final static int  ALL = HEIGHT * DEPTH * WIDTH;

int colortable[] = {
    //  赤系統
    0xFFFF7F00, // 深紅     コーラル 珊瑚           coral         
    0xFFFF007F, // 赤橙     オレンジ･レッド         orangeRed     
    0xFFFF0000, // 赤       レッド                  red           
    0xFFF4A560, // 赤茶     テンディ･ブラウン       sandyBrown    
    0xFFDB9370, // 淡褐色   タン   日焼             tan           
    0xFFDB7093, // 中赤紫   ミディアム･～           mVioletRed    
    0xFFCC3333, // 橙       オレンジ                orange        
    0xFFCC7F33, // 金       ゴールド                gold          
    0xFFCC3399, // 赤菫     バイオレット･レッド     violetRed     
    0xFFBC9191, // 桃       ピンク                  pink          
    0xFFA52B2B, // 茶       ブラウン                brown         
    0xFFA060A0, // 青菫     ブルー･バイオレット     blueViolet    
    0xFFA0A060, // 濁黄褐色 カーキィ                khaki         
    0xFF8E2323, // 耐火煉瓦 ファイヤブリック        firebrick     
    0xFF8E6B23, // 黄褐色   シエナ                  sienna        
    0xFF8E236B, // 栗色     マローン※1             maroon        
    0xFF704242, // 紅       サーモン                salmon        
    0xFF4F3030, // インド赤 インディアン･レッド     indianRed     
    0xFF4F304F, // 菫       バイオレット            violet        

    //  緑系統
    0xFFFFFF00, // 黄       イエロー                yellow        
    0xFF7FFF00, // 中新緑   ミディアム･～           mSpringGreen  
    0xFF00FF7F, // 新緑     スプリング･～           springGreen   
    0xFF00FFFF, // 水       シアン                  cyan          
    0xFF00FF00, // 緑       グリーン                green         
    0xFFEAEAAD, // 中鮮黄   ミディアム･～           mGoldenrod    
    0xFF93DB70, // 緑黄     グリーン･イエロー       greenYellow   
    0xFFDBDB70, // 鮮黄     ゴールデンラッド        goldenrod     
    0xFF70DB93, // 緑青     アクアマリン 藍玉       aquamarine    
    0xFFD8D8BF, // 小麦色   ウィット                wheat         
    0xFF33CC33, // ライム緑 ライム･グリーン         limeGreen     
    0xFF99CC33, // 黄緑     イエロー･グリーン       yellowGreen   
    0xFF33CC99, // 中緑青   ミディアム･～           mAquamarine   
    0xFF91BC91, // 薄緑     ペイル･グリーン         paleGreen     
    0xFF60A0A0, // 灰青     カデット･ブルー         cadetBlue     
    0xFF238E23, // 森緑     フォーレスト･～         forestGreen   
    0xFF238E6B, // 海緑     シー･グリーン           seaGreen      
    0xFF6B8E23, // 中森緑   ミディアム･～           mForestGreen  
    0xFF427042, // 中海緑   ミディアム･～           mSeaGreen     
    0xFF304F30, // 暗緑     ダーク･グリーン         darkGreen     
    0xFF4F4F30, // 暗黄緑   ダーク･オリーブ･～      darkOliveGreen

    //  青系統
    0xFF007FFF, // 石板色   スレイト･ブルー         slateBlue     
    0xFF7F00FF, // 中石板色 ミディアム･～           mSlateBlue    
    0xFFFF00FF, // 紫       マゼンタ                magenta       
    0xFFEAADEA, // 紫紺     プラム                  plum          
    0xFFADEAEA, // 青緑     ツァークワイズ トルコ石 turquoise     
    0xFF7093DB, // 暗青緑   ダーク･～               darkTurquoise 
    0xFF70DBDB, // 中青緑   ミディアム･～           mTurquoise    
    0xFF9370DB, // 中薄紫   ミディアム･～           mOrchid       
    0xFFDB70DB, // 薄紫     オルカッド  蘭          orchid        
    0xFFBFD8D8, // 明青     ライト･ブルー           lightBlue     
    0xFFD8BFD8, // 薊色     フィソル あざみ         thistle       
    0xFF3333CC, // 中青     ミディアム･～           mBlue         
    0xFF3399CC, // 空色     スカイ･ブルー           skyBlue       
    0xFF9933CC, // 暗薄紫   ダーク･オルカッド       darkOrchid    
    0xFF9191BC, // 明青灰   ライト･スチール･～      lightSteelBlue
    0xFF23238E, // 濃紺     ネービー･ブルー         navyBlue      
    0xFF236B8E, // 暗青灰   スチール･ブルー         steelBlue     
    0xFF6B238E, // 暗石板色 ダーク･～               darkSlateBlue 
    0xFF424270, // 濃青     コールンフラワー･～     cornflowerBlue
    0xFF30304F, // 暗青     ミッドナイト･～         midnightBlue  
    0xFF190233, // 微弱青   ウィーク･ブルー         weakBlue      
    0xFF0000FF, // 青       ブルー                  blue          

    0xFFFF7F00, // 深紅     コーラル 珊瑚           coral         
    0xFFFF007F, // 赤橙     オレンジ･レッド         orangeRed     
    0xFFFF0000, // 赤       レッド                  red           
    0xFFF4A560, // 赤茶     テンディ･ブラウン       sandyBrown    
    0xFFDB9370, // 淡褐色   タン   日焼             tan           
    0xFFDB7093, // 中赤紫   ミディアム･～           mVioletRed    
    0xFFCC3333 // 橙       オレンジ                orange        
};


void setup() {
  // 11x3x3 の タワー型Led Cube です。
  // 一層づつ色を変えながら数十色を表示します。
  initComponents();
  // initialize
}

void loop() {
/**
 * 平面
 */
  int pos = (Count ) % (HEIGHT + 1);
  for (int z= 0; z < HEIGHT; z++) {
    for (int y = 0; y < DEPTH;  y++) {
      for (int x = 0; x < WIDTH; x++) {
     //   ledcube1.setColor(z, y, x, 0x00ff0000);
          ledcube1.setColor(z, y, x, colortable[Index + z]);
      }
    }
  }
  Count++;
  Index++;
  if (Index > colortable.length  - HEIGHT) Index = 0;
  delay(100);               // wait for a second
}

void draw() {
  loop();
}

// システムの機能を完全に停止させる禁断のバルスメソッド
// 決して、使ってはならない。
void Balse() {
  System.exit(0);
}                                            

// digital OUTPUT
void digitalWrite(int outPin, int value) {
}

java.awt.Image readImage(String imgfile) {
  PImage pImage = loadImage(imgfile);
  return pImage.getImage();
}

//TimerTask内部クラス
class TimerTaskAudioStop extends java.util.TimerTask {
  public void run() {
    ToneFlag = 0;
    auOut.noSound();
    auOut.mute();
  }
}

// 指定された時間だけ停止する。単位はus
void delayMicroseconds(int t_us) {
  try {
    Thread.sleep(0, t_us * 1000);  // マイクロ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// 指定された時間だけ停止する。単位はms
void delay(long t_ms) {
  try {
    Thread.sleep(t_ms);  // ミリ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// arduino起動後の時間をus単位で返す。
long micros() {
  return (SystemStartTimeNS - System.nanoTime()) * 1000;
}

// 以下は、互換性のためだけに用意したダミー関数である。
void pinMode(int pin, int mode) {
   print("pin = " + pin + ", mode = " + mode);
}

/**
 * This method is called from within the constructor to initialize the form.
 * WARNING: Do NOT modify this code. The content of this method is always
 * regenerated by the Form Editor.
 */
// @SuppressWarnings("unchecked")
// <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
private void initComponents() {
  ToneFlag = 0;

  // digital
//  ledcube1  = new LedCube();
  ledcube1 = new LedCube(1, "LedCube Panel",  HEIGHT, DEPTH, WIDTH, 0, 0);

  minim = new ddf.minim.Minim(this);
  // get a line out from Minim, default bufferSize is 1024, default sample rate is 44100, bit depth is 16
  auOut = minim.getLineOut(ddf.minim.Minim.STEREO);
  // create a sine wave Oscillator, set to 440 Hz, at 0.5 amplitude, sample rate from line out
  sine = new ddf.minim.signals.SineWave(440, 0.5, auOut.sampleRate());
  // set the portamento speed on the oscillator to 200 milliseconds
  sine.portamento(200);

  DelayTimer = new java.util.Timer(); //タイマーインスタンス作成

  // add the oscillator to the line out
  auOut.addSignal(sine);
  auOut.noSound();  // Disables all signals currently attached to this.
  auOut.mute();
  ToneFlag = 0;

  SystemStartTimeMS = System.currentTimeMillis();  //ミリ秒で表される現在の時間を返します。
  SystemStartTimeNS = System.nanoTime(); // 利用可能でもっとも正確なシステムタイマーの現在の値をナノ秒単位で返します。
  size(320, 128);
  setLocation(0, 600);
  background(15, 115, 145);
  fill( 15, 115, 145);  rect(0, 0, 320, 128);
  fill( 30, 160, 145);  textSize(60); text(TITLE , 24, 68);
  fill( 45, 192, 145);  textSize(60); text(TITLE , 22, 66);
  fill(255, 255, 255);  textSize(60); text(TITLE , 20, 64);
  fill(255, 255, 255);  textSize(18); text("Ver. " + Arduino.getVersion(), 120, 108);
  setLocation(0, 600);
}// </editor-fold>//GEN-END:initComponents

// 変数の宣言部
// Variables declaration - do not modify//GEN-BEGIN:variables

private String TITLE   = "Emuduino";
private String VERSION = "0.49"; // Arduino.javaで使用するプロパティファイル中のバージョンを参照する。

private long SystemStartTimeMS;
private long SystemStartTimeNS;

private static final int HIGH   = 0x1;
private static final int LOW    = 0x0;
private static final int INPUT  = 0x0;
private static final int OUTPUT = 0x1;

private int ToneFlag = 0;  // 0の場合は停止状態。再生中は，その周波数を保持

private java.util.Timer            DelayTimer;
private java.util.TimerTask        TimerTaskAudioStop;
private ddf.minim.Minim            minim; // http://code.compartmental.net/minim/javadoc/
private ddf.minim.AudioOutput      auOut;
private ddf.minim.signals.SineWave sine;

private LedCube ledcube1;

// End of variables declaration//GEN-END:variables
