/*
 * name LedCubePos.pde
 * date Sun Jul 07 22:53:01 JST 2013
 * 
 * Released under the 'Buy Me a Beer' license
 * (If we ever meet, you buy me a beer)
 */

import net.triring.emuduino.*;
import ddf.minim.AudioOutput;
// Pin割り当て
// constants won't change. They're used here to 
// set pin numbers:
int    analogX =   0;  // Slider:INPUT:HORIZONTAL
int    analogY =   1;  // Slider:INPUT:VERTICAL
int  S19 =  19;  // LedCube
int  S18 =  18;  // LedCube

final static int  HEIGHT = 9; //高さ(z軸)
final static int  DEPTH  = 9; //奥行(y軸)
final static int  WIDTH  = 9; //幅(x軸)

int Count = 0;

void setup() {
  // 9x9x9 の Led Cube を設定。
  // xとyのスライダーの値を読み取り, 赤い平面上に緑の十字カーソルを表示します。
  initComponents();
  // initialize
}

void loop() {
  int c = 0;;
  int pos = (Count ) % (HEIGHT + 1);
  int x = (int)(analogRead(analogX) / 127);
  int y = (int)(analogRead(analogY) / 127);
  for (int i = 0; i < HEIGHT; i++) {
    for (int j = 0; j < DEPTH;  j++) {
      for (int k = 0; k < WIDTH; k++) {
        if (pos == i) {
          c = 0xffff0000;
          if (x == k) c = 0xff00ff00;
          if (y == j) c = 0xff00ff00;
        } else {
          c = 0x00000000;
        }
        ledcube1.setColor(i,j,k,c);
      }
    }
  }
  Count++;
  delay(500);               // wait for a second
}

void draw() {

  loop();
}

// システムの機能を完全に停止させる禁断のメソッド
// 決して、使ってはならない。
void balse() {
  System.exit(0);
}                                            

// analog INPUT
int analogRead(int inPin) {
    int value = 0;
    switch (inPin) {
        case   0 : value = slider0.getValue(); break;
        case   1 : value = slider1.getValue(); break;
    }
    return value;
}
java.awt.Image readImage(String imgfile) {
  PImage pImage = loadImage(imgfile);
  return pImage.getImage();
}

//TimerTask内部クラス
class TimerTaskAudioStop extends java.util.TimerTask {
  public void run() {
    ToneFlag = 0;
    auOut.noSound();
    auOut.mute();
  }
}

// 指定された時間だけ停止する。単位はus
void delayMicroseconds(int t_us) {
  try {
    Thread.sleep(0, t_us * 1000);  // マイクロ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// 指定された時間だけ停止する。単位はms
void delay(long t_ms) {
  try {
    Thread.sleep(t_ms);  // ミリ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// arduino起動後の時間をus単位で返す。
long micros() {
  return (SystemStartTimeNS - System.nanoTime()) * 1000;
}

// 以下は、互換性のためだけに用意したダミー関数である。
void pinMode(int pin, int mode) {
   print("pin = " + pin + ", mode = " + mode);
}

/**
 * This method is called from within the constructor to initialize the form.
 * WARNING: Do NOT modify this code. The content of this method is always
 * regenerated by the Form Editor.
 */
// @SuppressWarnings("unchecked")
// <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
private void initComponents() {
  ToneFlag = 0;

  // digital
      slider0 = new Slider(0 , "INPUT0",  120,  640, javax.swing.JSlider.HORIZONTAL);
      slider0.setSize(384, 120);
      slider1 = new Slider(1 , "INPUT1",    0, 360, javax.swing.JSlider.VERTICAL);
      slider1.setSize(120, 280);
      ledcube1 = new LedCube(1, "LedCube 1", HEIGHT, DEPTH, WIDTH, 120,   0);

  minim = new ddf.minim.Minim(this);
  // get a line out from Minim, default bufferSize is 1024, default sample rate is 44100, bit depth is 16
  auOut = minim.getLineOut(ddf.minim.Minim.STEREO);
  // create a sine wave Oscillator, set to 440 Hz, at 0.5 amplitude, sample rate from line out
  sine = new ddf.minim.signals.SineWave(440, 0.5, auOut.sampleRate());
  // set the portamento speed on the oscillator to 200 milliseconds
  sine.portamento(200);

  DelayTimer = new java.util.Timer(); //タイマーインスタンス作成

  // add the oscillator to the line out
  auOut.addSignal(sine);
  auOut.noSound();  // Disables all signals currently attached to this.
  auOut.mute();
  ToneFlag = 0;

  SystemStartTimeMS = System.currentTimeMillis();  //ミリ秒で表される現在の時間を返します。
  SystemStartTimeNS = System.nanoTime(); // 利用可能でもっとも正確なシステムタイマーの現在の値をナノ秒単位で返します。
  size(320, 128);
  setLocation(0, 600);
  background(15, 115, 145);
  fill( 15, 115, 145);  rect(0, 0, 320, 128);
  fill( 30, 160, 145);  textSize(60); text(TITLE , 24, 68);
  fill( 45, 192, 145);  textSize(60); text(TITLE , 22, 66);
  fill(255, 255, 255);  textSize(60); text(TITLE , 20, 64);
  fill(255, 255, 255);  textSize(18); text("Ver. " + Arduino.getVersion(), 120, 108);
  setLocation(0, 600);
}// </editor-fold>//GEN-END:initComponents

// 変数の宣言部
// Variables declaration - do not modify//GEN-BEGIN:variables

private String TITLE   = "Emuduino";
private String VERSION = "0.49"; // Arduino.javaで使用するプロパティファイル中のバージョンを参照する。

private long SystemStartTimeMS;
private long SystemStartTimeNS;

private static final int HIGH   = 0x1;
private static final int LOW    = 0x0;
private static final int INPUT  = 0x0;
private static final int OUTPUT = 0x1;

private int ToneFlag = 0;  // 0の場合は停止状態。再生中は，その周波数を保持

private java.util.Timer            DelayTimer;
private java.util.TimerTask        TimerTaskAudioStop;
private ddf.minim.Minim            minim; // http://code.compartmental.net/minim/javadoc/
private ddf.minim.AudioOutput      auOut;
private ddf.minim.signals.SineWave sine;

private Slider slider0;
private Slider slider1;
private LedCube ledcube1;


// End of variables declaration//GEN-END:variables


