class GOL {
  int Columns;
  int Rows   ;
  int    board[][];  // Game of life board
  int     next[][];
  int lifetime[][];

  public GOL(int Columns, int Rows) {
    this.Columns = Columns;      
    this.Rows    = Rows;
    board    = new int[Columns][Rows   ];
    next     = new int[Columns][Rows   ];
    lifetime = new int[Columns][Rows   ];
  }

  // board 配列の初期化
  public void init() {
    java.util.Random rnd = new java.util.Random();
    for (int i =1;i < Columns;i++) {
      for (int j =1;j < Rows;j++) {        
           board[i][j] = rnd.nextInt(2);
            next[i][j] = 0;
        lifetime[i][j] = 0;
      }
    }
  }
  // The process of creating the new generation
  public void generate() {
    // Loop through every spot in our 2D array and check spots neighbors
    for (int x = 0; x < Columns; x++) {
      for (int y = 0; y < Rows; y++) {
        // Add up all the states in a 3x3 surrounding grid
        int neighbors = 0;
        for (int i = -1; i <= 1; i++) {
          for (int j = -1; j <= 1; j++) {
            neighbors += board[(x+i+Columns)%Columns][(y+j+Rows)%Rows];
          }
        }
        // A little trick to subtract the current cell's state since
        // we added it in the above loop
        neighbors -= board[x][y];
        // Rules of Life
        if      ((board[x][y] == 1) && (neighbors <  2)) next[x][y] = 0;           // Loneliness
        else if ((board[x][y] == 1) && (neighbors >  3)) next[x][y] = 0;           // Overpopulation
        else if ((board[x][y] == 0) && (neighbors == 3)) next[x][y] = 1;           // Reproduction
        else                                            next[x][y] = board[x][y];  // Stasis
      }
    }

    // Next is now our board
    for (int x = 0; x < Columns; x++) {
      for (int y = 0; y < Rows; y++) {
        board[x][y] = next[x][y];
      }
    }
  }

  public int getCellInfo(int columns, int rows) {
    int num = board[columns][rows];
    return num2color(num);
  }

  public int num2color(int n) {
    int c = 0;
    switch(n) {
      case  0 : c = net.triring.emuduino.LedMatrix.OFF    ; break;
      case  1 : c = net.triring.emuduino.LedMatrix.BLUE   ; break;
      case  2 : c = net.triring.emuduino.LedMatrix.GREEN  ; break;
      case  3 : c = net.triring.emuduino.LedMatrix.AQUA   ; break;
      case  4 : c = net.triring.emuduino.LedMatrix.RED    ; break;
      case  5 : c = net.triring.emuduino.LedMatrix.MAGENTA; break;
      case  6 : c = net.triring.emuduino.LedMatrix.YELLOW ; break;
      default : c = net.triring.emuduino.LedMatrix.WHITE  ; break;
    }
    return c;
  }

  // This is the easy part, just draw the cells, fill 255 for '1', fill 0 for '0'
  public void display() {
    for ( int i = 0; i < Columns;i++) {
      for ( int j = 0; j < Rows;j++) {
        if ((board[i][j] == 1)) {     
          // ledmatrix1.setPixel(i, j, net.triring.emuduino.LedMatrix.GREEN);
        } 
        else {
          // ledmatrix1.setPixel(i, j, net.triring.emuduino.LedMatrix.OFF  );
        }
      }
    }
  }
}

