/*
 * name MorseCode.pde
 * date Mon Feb 25 19:54:46 JST 2013
 * 
 * Released under the 'Buy Me a Beer' license
 * (If we ever meet, you buy me a beer)
 */

import net.triring.emuduino.*;
import ddf.minim.AudioOutput;
// Pin割り当て
// constants won't change. They're used here to 
// set pin WaveLenbers:
int led_red =   2;  // Led:Red
int     sw3 =   3;  // Switch:Push
int     sw4 =   4;  // Switch:Push
int     spk =  10;  // Speaker:
int     S0  =   0;  // Serial
int     S1  =   1;  // Serial

int WaveLen = 200;


void setup() {
  // シリアルコンソールの入力エリアに英数字を入力して、送信ボタンを押してください。
  // 英数字に相当するモールス信号を再生します。
  // switch3を押すと,短点の音を再生します。
  // switch4を押すと,長点の音を再生します。
  initComponents();
  Serial.setSendText("Hello emuduino!");

  // initialize
     pinMode(led_red, OUTPUT);  // Led:Red
     pinMode(sw3,     INPUT );  // Switch:Push
     pinMode(sw4,     INPUT );  // Switch:Push
     pinMode(spk,     OUTPUT);  // Speaker:
}

void loop() {
  int ch = (int)Serial.read();
  if (ch != -1) {
    Serial.print(ch + ":" + (char)ch + "|");
    char2code(Character.toUpperCase(ch));
  }
  int state;
  state = digitalRead(sw3); // "dots"
  if (state == HIGH) tanten();

  state = digitalRead(sw4); //"dashes"
  if (state == HIGH) tyouten();
}

void draw() {
  loop();
}

int code_sound( int n )
{
int    j;
   for (j = 0; j < 6; j++){
      switch( code_table[n][j] ) {
         case 0 :                                  break;
         case 1 : Serial.print("= ");   tanten();  break;
         case 3 : Serial.print("=== "); tyouten(); break;
         default :                                 break;
      }
   }
   Serial.println(" ");
   char_space();
   return 0;
}


int send_on(int length)
{
   digitalWrite(led_red, HIGH);
      tone(spk, 1320);
         delay((long)(WaveLen * length));
      noTone(spk);
   digitalWrite(led_red, LOW );
   return 0;
}

int send_off( int length )
{
   noTone(spk);
   delay((long)(WaveLen * length));
   noTone(spk);
   return 0;
}

int kugirion()
{
   tone(spk,  3951);
   delay(50);
   noTone(spk);

   return 0;
}

int tanten()
{
   send_on( 1 ); send_off( 1 );
   return 0;
}

int tyouten()
{
   send_on( 3 ); send_off( 1 );
   return 0;
}

int char_space()
{
   send_off( 2 );
   return 0;
}

int word_space()
{
   send_off( 5 );
   return 0;
}

void char2code(int ch) {
    switch (ch) {
    // case ' ' : word_space(); break;
       case ' ' : code_sound(ch - ' '); break;
       case '!' : code_sound(ch - ' '); break;
       case '"' : code_sound(ch - ' '); break;
       case '#' : code_sound(ch - ' '); break;
       case '$' : code_sound(ch - ' '); break;
       case '%' : code_sound(ch - ' '); break;
       case '&' : code_sound(ch - ' '); break;
       case '\'' : code_sound(ch - ' '); break;
       case '(' : code_sound(ch - ' '); break;
       case ')' : code_sound(ch - ' '); break;
       case '*' : code_sound(ch - ' '); break;
       case '+' : code_sound(ch - ' '); break;
       case ',' : code_sound(ch - ' '); break;
       case '-' : code_sound(ch - ' '); break;
       case '.' : code_sound(ch - ' '); break;
       case '/' : code_sound(ch - ' '); break;
       case '0' : code_sound(ch - ' '); break;
       case '1' : code_sound(ch - ' '); break;
       case '2' : code_sound(ch - ' '); break;
       case '3' : code_sound(ch - ' '); break;
       case '4' : code_sound(ch - ' '); break;
       case '5' : code_sound(ch - ' '); break;
       case '6' : code_sound(ch - ' '); break;
       case '7' : code_sound(ch - ' '); break;
       case '8' : code_sound(ch - ' '); break;
       case '9' : code_sound(ch - ' '); break;
       case ':' : code_sound(ch - ' '); break;
       case ';' : code_sound(ch - ' '); break;
       case '<' : code_sound(ch - ' '); break;
       case '=' : code_sound(ch - ' '); break;
       case '>' : code_sound(ch - ' '); break;
       case '?' : code_sound(ch - ' '); break;
       case '@' : code_sound(ch - ' '); break;
       case 'A' : code_sound(ch - ' '); break;
       case 'B' : code_sound(ch - ' '); break;
       case 'C' : code_sound(ch - ' '); break;
       case 'D' : code_sound(ch - ' '); break;
       case 'E' : code_sound(ch - ' '); break;
       case 'F' : code_sound(ch - ' '); break;
       case 'G' : code_sound(ch - ' '); break;
       case 'H' : code_sound(ch - ' '); break;
       case 'I' : code_sound(ch - ' '); break;
       case 'J' : code_sound(ch - ' '); break;
       case 'K' : code_sound(ch - ' '); break;
       case 'L' : code_sound(ch - ' '); break;
       case 'M' : code_sound(ch - ' '); break;
       case 'N' : code_sound(ch - ' '); break;
       case 'O' : code_sound(ch - ' '); break;
       case 'P' : code_sound(ch - ' '); break;
       case 'Q' : code_sound(ch - ' '); break;
       case 'R' : code_sound(ch - ' '); break;
       case 'S' : code_sound(ch - ' '); break;
       case 'T' : code_sound(ch - ' '); break;
       case 'U' : code_sound(ch - ' '); break;
       case 'V' : code_sound(ch - ' '); break;
       case 'W' : code_sound(ch - ' '); break;
       case 'X' : code_sound(ch - ' '); break;
       case 'Y' : code_sound(ch - ' '); break;
       case 'Z' : code_sound(ch - ' '); break;
    }
}
// システムの機能を完全に停止させる禁断のメソッド
// 決して、使ってはならない。
void balse() {
  System.exit(0);
}                                            

// digital INPUT
int digitalRead(int inPin) {
    int value = 0;
    switch (inPin) {
        case 3 : value = switch3.isState(); break;
        case 4 : value = switch4.isState(); break;
    }
    return value;
}
// digital OUTPUT
void digitalWrite(int outPin, int value) {
    switch (outPin) {
        case 2 : led2.setState(value); break;
    }
}
// Speakerで使用する関数群

void tone(int pin, int frequency) {
  if (ToneFlag == frequency) return;
  ToneFlag = frequency;
  speaker10.setFrequency(frequency);
  sine.setFreq((float)frequency);
  auOut.unmute();
  auOut.sound();
}

void tone(int pin, int frequency, long duration) {
  if (ToneFlag == frequency) return;
  ToneFlag = frequency;
  sine.setFreq((float)frequency);
  auOut.unmute();
  auOut.sound();
  TimerTaskAudioStop timerTask = new TimerTaskAudioStop(); //タイマータスクインスタンス作成
  //タイマー開始
  DelayTimer.schedule(timerTask, duration);
}

void noTone(int pin) {
  ToneFlag = 0;
  speaker10.setFrequency(0);
  auOut.mute();
  auOut.noSound();
}
java.awt.Image readImage(String imgfile) {
  PImage pImage = loadImage(imgfile);
  return pImage.getImage();
}

//TimerTask内部クラス
class TimerTaskAudioStop extends java.util.TimerTask {
  public void run() {
    ToneFlag = 0;
    auOut.noSound();
    auOut.mute();
  }
}

// 指定された時間だけ停止する。単位はus
void delayMicroseconds(int t_us) {
  try {
    Thread.sleep(0, t_us * 1000);  // マイクロ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// 指定された時間だけ停止する。単位はms
void delay(long t_ms) {
  try {
    Thread.sleep(t_ms);  // ミリ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// arduino起動後の時間をus単位で返す。
long micros() {
  return (SystemStartTimeNS - System.nanoTime()) * 1000;
}

// 以下は、互換性のためだけに用意したダミー関数である。
void pinMode(int pin, int mode) {
   print("pin = " + pin + ", mode = " + mode);
}

/**
 * This method is called from within the constructor to initialize the form.
 * WARNING: Do NOT modify this code. The content of this method is always
 * regenerated by the Form Editor.
 */
// @SuppressWarnings("unchecked")
// <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
private void initComponents() {
  ToneFlag = 0;
  // digital
       led2 = new Led(     2 , "red",         0,   0);
    switch3 = new Switch(  3 , "dots",        0, 210);
    switch4 = new Switch(  4 , "dashes",    120, 210);
  speaker10 = new Speaker(10 , "speaker10", 120,   0);
     Serial = new SerialConsole(320, 0);

  minim = new ddf.minim.Minim(this);
  // get a line out from Minim, default bufferSize is 1024, default sample rate is 44100, bit depth is 16
  auOut = minim.getLineOut(ddf.minim.Minim.STEREO);
  // create a sine wave Oscillator, set to 440 Hz, at 0.5 amplitude, sample rate from line out
  sine = new ddf.minim.signals.SineWave(440, 0.5, auOut.sampleRate());
  // set the portamento speed on the oscillator to 200 milliseconds
  sine.portamento(200);

  DelayTimer = new java.util.Timer(); //タイマーインスタンス作成

  // add the oscillator to the line out
  auOut.addSignal(sine);
  auOut.noSound();  // Disables all signals currently attached to this.
  auOut.mute();
  ToneFlag = 0;

  SystemStartTimeMS = System.currentTimeMillis();  //ミリ秒で表される現在の時間を返します。
  SystemStartTimeNS = System.nanoTime(); // 利用可能でもっとも正確なシステムタイマーの現在の値をナノ秒単位で返します。
  size(320, 128);
  setLocation(0, 600);
  background(15, 115, 145);
  fill( 15, 115, 145);  rect(0, 0, 320, 128);
  fill( 30, 160, 145);  textSize(60); text(TITLE , 24, 68);
  fill( 45, 192, 145);  textSize(60); text(TITLE , 22, 66);
  fill(255, 255, 255);  textSize(60); text(TITLE , 20, 64);
  fill(255, 255, 255);  textSize(18); text("Ver. " + Arduino.getVersion(), 120, 108);
  setLocation(0, 600);
}// </editor-fold>//GEN-END:initComponents

// 変数の宣言部
// Variables declaration - do not modify//GEN-BEGIN:variables

private String TITLE   = "Emuduino";
private String VERSION = "0.49"; // Arduino.javaで使用するプロパティファイル中のバージョンを参照する。

private long SystemStartTimeMS;
private long SystemStartTimeNS;

private static final int HIGH   = 0x1;
private static final int LOW    = 0x0;
private static final int INPUT  = 0x0;
private static final int OUTPUT = 0x1;

private int ToneFlag = 0;  // 0の場合は停止状態。再生中は，その周波数を保持

private int code_table[][] = {
    {0,0,0,0,0,0},     /*   */
    {0,0,0,0,0,0},     /* ! */
    {1,3,1,1,3,1},     /* " */
    {0,0,0,0,0,0},     /* # */
    {0,0,0,0,0,0},     /* $ */
    {0,0,0,0,0,0},     /* % */
    {0,0,0,0,0,0},     /* & */
    {1,3,3,3,3,1},     /* ' */
    {3,1,3,3,1,0},     /* ( */
    {3,1,3,3,1,3},     /* ) */
    {0,0,0,0,0,0},     /* * */
    {0,0,0,0,0,0},     /* + */
    {3,3,1,1,3,3},     /* , */
    {0,0,0,0,0,0},     /* - */
    {1,3,1,3,1,3},     /* . */
    {3,1,1,3,1,0},     /* / */
    {3,3,3,3,3,0},     /* 0 */
    {1,3,3,3,3,0},     /* 1 */
    {1,1,3,3,3,0},     /* 2 */
    {1,1,1,3,3,0},     /* 3 */
    {1,1,1,1,3,0},     /* 4 */
    {1,1,1,1,1,0},     /* 5 */
    {3,1,1,1,1,0},     /* 6 */
    {3,3,1,1,1,0},     /* 7 */
    {3,3,3,1,1,0},     /* 8 */
    {3,3,3,3,1,0},     /* 9 */
    {3,3,3,1,1,1},     /* : */
    {0,0,0,0,0,0},     /* ; */
    {0,0,0,0,0,0},     /* < */
    {0,0,0,0,0,0},     /* = */
    {0,0,0,0,0,0},     /* > */
    {1,1,3,3,1,1},     /* ? */
    {0,0,0,0,0,0},     /* @ */
    {1,3,0,0,0,0},     /* A */
    {3,1,1,1,0,0},     /* B */
    {3,1,3,1,0,0},     /* C */
    {3,1,1,0,0,0},     /* D */
    {1,0,0,0,0,0},     /* E */
    {1,1,3,1,0,0},     /* F */
    {3,3,1,0,0,0},     /* G */
    {1,1,1,1,0,0},     /* H */
    {1,1,0,0,0,0},     /* I */
    {1,3,3,3,0,0},     /* J */
    {3,1,3,0,0,0},     /* K */
    {1,3,1,1,0,0},     /* L */
    {3,3,0,0,0,0},     /* M */
    {3,1,0,0,0,0},     /* N */
    {3,3,3,0,0,0},     /* O */
    {1,3,3,1,0,0},     /* P */
    {3,3,1,3,0,0},     /* Q */
    {1,3,1,0,0,0},     /* R */
    {1,1,1,0,0,0},     /* S */
    {3,0,0,0,0,0},     /* T */
    {1,1,3,0,0,0},     /* U */
    {1,1,1,3,0,0},     /* V */
    {1,3,3,0,0,0},     /* W */
    {3,1,1,3,0,0},     /* X */
    {3,1,3,3,0,0},     /* Y */
    {3,3,1,1,0,0}      /* Z */
};

private java.util.Timer            DelayTimer;
private java.util.TimerTask        TimerTaskAudioStop;
private ddf.minim.Minim            minim; // http://code.compartmental.net/minim/javadoc/
private ddf.minim.AudioOutput      auOut;
private ddf.minim.signals.SineWave sine;

private Led led2;
private Switch switch3;
private Switch switch4;
private Speaker speaker10;
private SerialConsole Serial;


// End of variables declaration//GEN-END:variables


