/*
 * name MrRoboto.pde
 * date Thu Mar 14 14:46:40 JST 2013
 * 
 * Released under the 'Buy Me a Beer' license
 * (If we ever meet, you buy me a beer)
 */

import net.triring.emuduino.*;
import ddf.minim.AudioOutput;
// Pin割り当て
// constants won't change. They're used here to 
// set pin numbers:
int   RightLED =   3;  // Right LED (eye)
int    LeftLED =   9;  // Left LED (eye)
// int     Buzzer =  6;  // Buzzer (nose)
int     Buzzer =  10;  // Buzzer (nose)
int  Photocell =   0;  // Photocell (left ear)
int TempSensor =   1;  // Temperature Sensor (right ear
int   S0 =   0;  // Serial
int   S1 =   1;  // Serial
int  S19 =  19;  // Lcd0802  LCD (mouth)
int  S18 =  18;  // Lcd0802

float beatsPerMinute = 60;
int domoAregatoLength = 12;

int NOTE_REST =   0;
int NOTE_DS4  = 311;
int NOTE_F4   = 349;

// domoAregotoNotes is an array, which contains the
// sequence of notes Mr. Roboto will play.
// int domoAregatoNotes[domoAregatoLength] = {
int [] domoAregatoNotes = {
  NOTE_F4, NOTE_F4, NOTE_F4, NOTE_F4, NOTE_F4, NOTE_DS4, NOTE_REST,
  NOTE_F4, NOTE_F4, NOTE_F4, NOTE_F4, NOTE_DS4};


// domoAregatoDurations contains the duration of each
// note, which we defined in domoAregatoNotes
// note durations: 4 = quarter note, 8 = eighth note, etc.:
// int domoAregatoDurations[domoAregatoLength] = {
int[] domoAregatoDurations = {
  8, 8, 8, 8, 8, 4, 16,// do-mo-ar-e-ga-to-
  4, 4, 8, 8, 4 };     // mis-ter-ro-bot-o

void setup() {
// sparkfunsparkfunのMr. Roboto Kitをemuduinoで再現してみました。
// KIT-11257[https://www.sparkfun.com/products/11257]
  initComponents();
  // initialize
     pinMode(RightLED, OUTPUT);  // Led:Red
     pinMode(LeftLED,  OUTPUT);  // Led:Red
     pinMode(Buzzer,   OUTPUT);  // Speaker:
     lcd.begin(16, 2);
     lcd.print(0, "do-mo-ar-e-ga-to");
     lcd.print(1, "mis-ter-ro-bot-o");
  /* Each time we go through this for loop it'll output one
     note. It'll run through the for loop 12 times (or whatever
     you've got domoAregatoLength set to */
  for (int thisNote = 0; thisNote < domoAregatoLength; thisNote++) 
  {
    /* to calculate the note duration in ms divide beatsPerMinute
       into 60000 (1000 ms/s * 60 s/m).
       Then divide it by the note type.
       e.g. quarter note = 1000 / 4, eighth note = 1000/8, etc. */
    int noteDuration = (int)((60000/beatsPerMinute)/domoAregatoDurations[thisNote]);
    
    /* tone is what makes the magic happen. This is how Mr. Roboto 
       makes noise.
       The first parameter in tone() is the pin.
       The second parameter is the note.
       The third parameter is the duration of the note. */
    tone(Buzzer, domoAregatoNotes[thisNote],noteDuration);

    // to distinguish the notes, set a minimum time between them.
    // the note's duration + 30% seems to work well:
    int pauseBetweenNotes = (int)(noteDuration * 1.30);
    delay(pauseBetweenNotes);
  }
  delay(5000);  // pause, let Mr. Roboto take a breath
  Serial.begin(9600);
  Serial.println("Start");
}

void loop() {
  // First create a variable to store the temperature readings
  // We'll creatively call it temperatureReading.
  int temperatureReading;
  digitalWrite(3, HIGH);
  // Now we'll use analogRead() to get the analog value of the
  // temperature pin. And we'll store that value in
  // temperatureReading;
  temperatureReading = analogRead(TempSensor); 
  
  // but that value doesn't really mean anything to you. It's just
  // some number between 0 and 1023. Which actually represents a
  // voltage between 0 and 5V. Lets convert it to Celsius.
  
  // First find the voltage - divide by 1024, and multiply by 5V
  float temperatureVoltage = (float) temperatureReading * 5 / 1024;
  
  // Next allow for the temperature sensor's offset, which is 0.5V.
  temperatureVoltage = temperatureVoltage - 0.5;
  
  // Now, the temperature should be equal to 0.1V / degree C
  float celsiusTemperature = temperatureVoltage * 100;
  
  // And let's print that out now. First some text:
  Serial.print("The celsius temperature is: ");
  // Then the temperature we calculated
  Serial.print(celsiusTemperature);
  // Then print some fancy characters, and a new line.
  Serial.print(" ");    // Print a space
  Serial.print("°");   // This is the ° symbol code number
  Serial.print("C\n");  // and a C
  
  // For some more practice, you could try converting that celsius
  // value into farenheit. If you're like me, you have know idea
  // if 25°C is room temperature, boiling or freezing.
  
  // Let's also delay for a brief moment, so this all doesn't stream
  // by faster than we can actually see.
  delay(1000);  // delay for 1000ms (1 second)
}

void draw() {
  loop();
}

// システムの機能を完全に停止させる禁断のメソッド
// 決して、使ってはならない。
void balse() {
  System.exit(0);
}                                            

// digital OUTPUT
void digitalWrite(int outPin, int value) {
    switch (outPin) {
        case 3 : led3.setState(value); break;
        case 9 : led9.setState(value); break;
    }
}
// analog INPUT
int analogRead(int inPin) {
    int value = 0;
    switch (inPin) {
        case   0 : value = slider0.getValue(); break;
        case   1 : value = slider1.getValue(); break;
    }
    return value;
}
// Speakerで使用する関数群

void tone(int pin, int frequency) {
  if (ToneFlag == frequency) return;
  ToneFlag = frequency;
  speaker10.setFrequency(frequency);
  sine.setFreq((float)frequency);
  auOut.unmute();
  auOut.sound();
}

void tone(int pin, int frequency, long duration) {
  if (ToneFlag == frequency) return;
  ToneFlag = frequency;
  sine.setFreq((float)frequency);
  auOut.unmute();
  auOut.sound();
  TimerTaskAudioStop timerTask = new TimerTaskAudioStop(); //タイマータスクインスタンス作成
  //タイマー開始
  DelayTimer.schedule(timerTask, duration);
}

void noTone(int pin) {
  ToneFlag = 0;
  speaker10.setFrequency(0);
  auOut.mute();
  auOut.noSound();
}
java.awt.Image readImage(String imgfile) {
  PImage pImage = loadImage(imgfile);
  return pImage.getImage();
}

//TimerTask内部クラス
class TimerTaskAudioStop extends java.util.TimerTask {
  public void run() {
    ToneFlag = 0;
    auOut.noSound();
    auOut.mute();
  }
}

// 指定された時間だけ停止する。単位はus
void delayMicroseconds(int t_us) {
  try {
    Thread.sleep(0, t_us * 1000);  // マイクロ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// 指定された時間だけ停止する。単位はms
void delay(long t_ms) {
  try {
    Thread.sleep(t_ms);  // ミリ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// arduino起動後の時間をus単位で返す。
long micros() {
  return (SystemStartTimeNS - System.nanoTime()) * 1000;
}

// 以下は、互換性のためだけに用意したダミー関数である。
void pinMode(int pin, int mode) {
   print("pin = " + pin + ", mode = " + mode);
}

/**
 * This method is called from within the constructor to initialize the form.
 * WARNING: Do NOT modify this code. The content of this method is always
 * regenerated by the Form Editor.
 */
// @SuppressWarnings("unchecked")
// <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
private void initComponents() {
  ToneFlag = 0;

  // digital
     led3 = new Led(     3 , "red",         270,   0);
     led9 = new Led(     9 , "red",         120,   0);
speaker10 = new Speaker(10 , "Buzzer",      180, 144);
  slider0 = new Slider(  0 , "Photocell",     0,  80, javax.swing.JSlider.VERTICAL  );
  slider1 = new Slider(  1 , "Temp sensor", 390,  80, javax.swing.JSlider.VERTICAL  );
   Serial = new SerialConsole(              512,  80);
      lcd = new Lcd(1 , 120, 360, 1602);

  minim = new ddf.minim.Minim(this);
  // get a line out from Minim, default bufferSize is 1024, default sample rate is 44100, bit depth is 16
  auOut = minim.getLineOut(ddf.minim.Minim.STEREO);
  // create a sine wave Oscillator, set to 440 Hz, at 0.5 amplitude, sample rate from line out
  sine = new ddf.minim.signals.SineWave(440, 0.5, auOut.sampleRate());
  // set the portamento speed on the oscillator to 200 milliseconds
  sine.portamento(200);

  DelayTimer = new java.util.Timer(); //タイマーインスタンス作成

  // add the oscillator to the line out
  auOut.addSignal(sine);
  auOut.noSound();  // Disables all signals currently attached to this.
  auOut.mute();
  ToneFlag = 0;

  SystemStartTimeMS = System.currentTimeMillis();  //ミリ秒で表される現在の時間を返します。
  SystemStartTimeNS = System.nanoTime(); // 利用可能でもっとも正確なシステムタイマーの現在の値をナノ秒単位で返します。
  size(320, 128);
  setLocation(0, 600);
  background(15, 115, 145);
  fill( 15, 115, 145);  rect(0, 0, 320, 128);
  fill( 30, 160, 145);  textSize(60); text(TITLE , 24, 68);
  fill( 45, 192, 145);  textSize(60); text(TITLE , 22, 66);
  fill(255, 255, 255);  textSize(60); text(TITLE , 20, 64);
  fill(255, 255, 255);  textSize(18); text("Ver. " + Arduino.getVersion(), 120, 108);
  setLocation(0, 600);
}// </editor-fold>//GEN-END:initComponents

// 変数の宣言部
// Variables declaration - do not modify//GEN-BEGIN:variables

private String TITLE   = "Emuduino";
private String VERSION = "0.49"; // Arduino.javaで使用するプロパティファイル中のバージョンを参照する。

private long SystemStartTimeMS;
private long SystemStartTimeNS;

private static final int HIGH   = 0x1;
private static final int LOW    = 0x0;
private static final int INPUT  = 0x0;
private static final int OUTPUT = 0x1;

private int ToneFlag = 0;  // 0の場合は停止状態。再生中は，その周波数を保持

private java.util.Timer            DelayTimer;
private java.util.TimerTask        TimerTaskAudioStop;
private ddf.minim.Minim            minim; // http://code.compartmental.net/minim/javadoc/
private ddf.minim.AudioOutput      auOut;
private ddf.minim.signals.SineWave sine;

private Led led3;
private Led led9;
private Speaker speaker10;
private Slider slider0;
private Slider slider1;
private SerialConsole Serial;
private Lcd lcd;


// End of variables declaration//GEN-END:variables


